# Class DragSourceEvent

java.lang.Object
java.util.EventObject
org.eclipse.swt.events.TypedEvent
org.eclipse.swt.dnd.DragSourceEvent

All Implemented Interfaces:
  `Serializable`

public class DragSourceEvent extends TypedEvent
The DragSourceEvent contains the event information passed in the methods of the DragSourceListener.

See Also:
  - `DragSourceListener`
  - Sample code and further information
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`TransferData`
`dataType`
The type of data requested.
`int`
`detail`
The operation that was performed.
`boolean`
`doit`
In dragStart, the doit field determines if the drag and drop operation should proceed; in dragFinished, the doit field indicates whether the operation was performed successfully.
`Image`
`image`
The drag source image to be displayed during the drag.
`int`
`offsetX`
In dragStart, the x offset (relative to the image) where the drag source image will be displayed.
`int`
`offsetY`
In dragStart, the y offset (relative to the image) where the drag source image will be displayed.
`int`
`x`
In dragStart, the x coordinate (relative to the control) of the position the mouse went down to start the drag.
`int`
`y`
In dragStart, the y coordinate (relative to the control) of the position the mouse went down to start the drag.

### Fields inherited from class TypedEvent

`data, display, time, widget`

### Fields inherited from class EventObject

`source`

## Constructor Summary

Constructors
Constructor
Description
`DragSourceEvent(org.eclipse.swt.dnd.DNDEvent e)`
Constructs a new instance of this class based on the information in the given untyped event.

## Method Summary

Modifier and Type
Method
Description
`String`
`toString()`
Returns a string containing a concise, human-readable description of the receiver.

### Methods inherited from class EventObject

`getSource`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### detail

public int detail
The operation that was performed.

See Also:
  - `DND.DROP_NONE`
  - `DND.DROP_MOVE`
  - `DND.DROP_COPY`
  - `DND.DROP_LINK`
  - `DND.DROP_TARGET_MOVE`

### doit

public boolean doit
In dragStart, the doit field determines if the drag and drop operation should proceed; in dragFinished, the doit field indicates whether the operation was performed successfully.

In dragStart:

Flag to determine if the drag and drop operation should proceed. The application can set this value to false to prevent the drag from starting. Set to true by default.

In dragSetData:

This will be set to true when the call to dragSetData is made. Set it to false to cancel the drag.

In dragFinished:

Flag to indicate if the operation was performed successfully. True if the operation was performed successfully.

### x

public int x
In dragStart, the x coordinate (relative to the control) of the position the mouse went down to start the drag.

Since:
  3.2

### y

public int y
In dragStart, the y coordinate (relative to the control) of the position the mouse went down to start the drag.

Since:
  3.2

### dataType

public TransferData dataType
The type of data requested. Data provided in the data field must be of the same type.

### image

public Image image
The drag source image to be displayed during the drag.

A value of null indicates that no drag image will be displayed.

The default value is null.

Since:
  3.3

### offsetX

public int offsetX
In dragStart, the x offset (relative to the image) where the drag source image will be displayed.

Since:
  3.5

### offsetY

public int offsetY
In dragStart, the y offset (relative to the image) where the drag source image will be displayed.

Since:
  3.5

## Constructor Details

### DragSourceEvent

public DragSourceEvent(org.eclipse.swt.dnd.DNDEvent e)
Constructs a new instance of this class based on the information in the given untyped event.

Parameters:
  `e` - the untyped event containing the information

## Method Details

### toString

public String toString()
Returns a string containing a concise, human-readable description of the receiver.

Overrides:
  `toString` in class `TypedEvent`
Returns:
  a string representation of the event